
from datetime import datetime
from decimal import Decimal

class BeckhoffOutput:
    """Interface of the application data type BeckhoffOutput. 
       Generated by: EASy-Producer."""
 
    
    def getIPicCounter(self) -> int:
        """Returns the value of {@code iPicCounter}.
        
           Returns:
             - the value of iPicCounter"""
        raise NotImplementedError
    
    def getIPicScene(self) -> int:
        """Returns the value of {@code iPicScene}.
        
           Returns:
             - the value of iPicScene"""
        raise NotImplementedError
    
    def getBPicTrigger(self) -> bool:
        """Returns the value of {@code bPicTrigger}.
        
           Returns:
             - the value of bPicTrigger"""
        raise NotImplementedError
    
    
    def setIPicCounter(self, v):
        """Changes the value of {@code iPicCounter}.
        
           Parameters:
             - v -- the new value of iPicCounter, may be of type int or the corresponding numpy type"""
        raise NotImplementedError
    
    def setIPicScene(self, v):
        """Changes the value of {@code iPicScene}.
        
           Parameters:
             - v -- the new value of iPicScene, may be of type int or the corresponding numpy type"""
        raise NotImplementedError
    
    def setBPicTrigger(self, v: bool):
        """Changes the value of {@code bPicTrigger}.
        
           Parameters:
             - v -- the new value of bPicTrigger"""
        raise NotImplementedError
    
    
    #Indeed, there are 2.4 decorators for this, but for now we want to have all here: pythonic field access
    #backed by getter/setter and the ability to replace data classes by e.g. projecting or data enhancing
    #functionality (original idea of the "interfaces" with similar naming as in Java. It may be that the 
    #interfaces become superfluous due to the properties, but let's leave them in for now.
    iPicCounter = property(getIPicCounter, setIPicCounter)
    iPicScene = property(getIPicScene, setIPicScene)
    bPicTrigger = property(getBPicTrigger, setBPicTrigger)
    
