
from datetime import datetime
from decimal import Decimal

class DecisionResult:
    """Interface of the application data type DecisionResult. 
       Generated by: EASy-Producer."""
 
    
    def getIo(self) -> bool:
        """Returns the value of {@code io}.
        
           Returns:
             - the value of io"""
        raise NotImplementedError
    
    def getIoReason(self) -> int:
        """Returns the value of {@code ioReason}.
        
           Returns:
             - the value of ioReason"""
        raise NotImplementedError
    
    def getError(self) -> list:
        """Returns the value of {@code error}. Error class names (TBD).
        
           Returns:
             - the value of error"""
        raise NotImplementedError
    
    def getErrorConfidence(self) -> list:
        """Returns the value of {@code errorConfidence}. Confidence values (0;1) for error classes in errors.
        
           Returns:
             - the value of errorConfidence"""
        raise NotImplementedError
    
    def getImg1Error(self) -> list:
        """Returns the value of {@code img1Error}. Error class names for image 1 (TBD).
        
           Returns:
             - the value of img1Error"""
        raise NotImplementedError
    
    def getImg2Error(self) -> list:
        """Returns the value of {@code img2Error}. Error class names for image 2 (TBD).
        
           Returns:
             - the value of img2Error"""
        raise NotImplementedError
    
    def getImg3Error(self) -> list:
        """Returns the value of {@code img3Error}. Error class names for image 3 (TBD).
        
           Returns:
             - the value of img3Error"""
        raise NotImplementedError
    
    def getImageUri(self) -> list:
        """Returns the value of {@code imageUri}.
        
           Returns:
             - the value of imageUri"""
        raise NotImplementedError
    
    def getRobotId(self) -> int:
        """Returns the value of {@code robotId}.
        
           Returns:
             - the value of robotId"""
        raise NotImplementedError
    
    def getAiId(self) -> str:
        """Returns the value of {@code aiId}. Unique id of AI (Lenze, ISMLL, RapidMiner).
        
           Returns:
             - the value of aiId"""
        raise NotImplementedError
    
    def getModelId(self) -> str:
        """Returns the value of {@code modelId}. Active AI model id.
        
           Returns:
             - the value of modelId"""
        raise NotImplementedError
    
    
    def setIo(self, v: bool):
        """Changes the value of {@code io}.
        
           Parameters:
             - v -- the new value of io"""
        raise NotImplementedError
    
    def setIoReason(self, v):
        """Changes the value of {@code ioReason}.
        
           Parameters:
             - v -- the new value of ioReason, may be of type int or the corresponding numpy type"""
        raise NotImplementedError
    
    def setError(self, v: list):
        """Changes the value of {@code error}. Error class names (TBD).
        
           Parameters:
             - v -- the new value of error"""
        raise NotImplementedError
    
    def setErrorConfidence(self, v: list):
        """Changes the value of {@code errorConfidence}. Confidence values (0;1) for error classes in errors.
        
           Parameters:
             - v -- the new value of errorConfidence"""
        raise NotImplementedError
    
    def setImg1Error(self, v: list):
        """Changes the value of {@code img1Error}. Error class names for image 1 (TBD).
        
           Parameters:
             - v -- the new value of img1Error"""
        raise NotImplementedError
    
    def setImg2Error(self, v: list):
        """Changes the value of {@code img2Error}. Error class names for image 2 (TBD).
        
           Parameters:
             - v -- the new value of img2Error"""
        raise NotImplementedError
    
    def setImg3Error(self, v: list):
        """Changes the value of {@code img3Error}. Error class names for image 3 (TBD).
        
           Parameters:
             - v -- the new value of img3Error"""
        raise NotImplementedError
    
    def setImageUri(self, v: list):
        """Changes the value of {@code imageUri}.
        
           Parameters:
             - v -- the new value of imageUri"""
        raise NotImplementedError
    
    def setRobotId(self, v):
        """Changes the value of {@code robotId}.
        
           Parameters:
             - v -- the new value of robotId, may be of type int or the corresponding numpy type"""
        raise NotImplementedError
    
    def setAiId(self, v: str):
        """Changes the value of {@code aiId}. Unique id of AI (Lenze, ISMLL, RapidMiner).
        
           Parameters:
             - v -- the new value of aiId"""
        raise NotImplementedError
    
    def setModelId(self, v: str):
        """Changes the value of {@code modelId}. Active AI model id.
        
           Parameters:
             - v -- the new value of modelId"""
        raise NotImplementedError
    
    
    #Indeed, there are 2.4 decorators for this, but for now we want to have all here: pythonic field access
    #backed by getter/setter and the ability to replace data classes by e.g. projecting or data enhancing
    #functionality (original idea of the "interfaces" with similar naming as in Java. It may be that the 
    #interfaces become superfluous due to the properties, but let's leave them in for now.
    io = property(getIo, setIo)
    ioReason = property(getIoReason, setIoReason)
    error = property(getError, setError)
    errorConfidence = property(getErrorConfidence, setErrorConfidence)
    img1Error = property(getImg1Error, setImg1Error)
    img2Error = property(getImg2Error, setImg2Error)
    img3Error = property(getImg3Error, setImg3Error)
    imageUri = property(getImageUri, setImageUri)
    robotId = property(getRobotId, setRobotId)
    aiId = property(getAiId, setAiId)
    modelId = property(getModelId, setModelId)
    
