
from datetime import datetime
from decimal import Decimal

class DriveBeckhoffOutput:
    """Interface of the application data type DriveBeckhoffOutput. 
       Generated by: EASy-Producer."""
 
    
    def getBWaitForCommand(self) -> bool:
        """Returns the value of {@code bWaitForCommand}. Combination of Enabled, waiting for command.
        
           Returns:
             - the value of bWaitForCommand"""
        raise NotImplementedError
    
    def getIFriction_actual(self) -> int:
        """Returns the value of {@code iFriction_actual}. Actual friction incident (read-only)
        
           Returns:
             - the value of iFriction_actual"""
        raise NotImplementedError
    
    def getITension_actual(self) -> int:
        """Returns the value of {@code iTension_actual}. Actual tension incident (read-only)
        
           Returns:
             - the value of iTension_actual"""
        raise NotImplementedError
    
    def getError(self) -> bool:
        """Returns the value of {@code Error}. Becomes true in case of an error. See ErrorID.
        
           Returns:
             - the value of Error"""
        raise NotImplementedError
    
    def getErrorID(self) -> int:
        """Returns the value of {@code ErrorID}. If error is true, returns an error identification code.
        
           Returns:
             - the value of ErrorID"""
        raise NotImplementedError
    
    def getRPosition_actual(self) -> float:
        """Returns the value of {@code rPosition_actual}. Actual position in mm +/- 1mm, may be negative although 0
        
           Returns:
             - the value of rPosition_actual"""
        raise NotImplementedError
    
    def getSAxisMessage(self) -> str:
        """Returns the value of {@code sAxisMessage}. Status message from drive
        
           Returns:
             - the value of sAxisMessage"""
        raise NotImplementedError
    
    
    def setBWaitForCommand(self, v: bool):
        """Changes the value of {@code bWaitForCommand}. Combination of Enabled, waiting for command.
        
           Parameters:
             - v -- the new value of bWaitForCommand"""
        raise NotImplementedError
    
    def setError(self, v: bool):
        """Changes the value of {@code Error}. Becomes true in case of an error. See ErrorID.
        
           Parameters:
             - v -- the new value of Error"""
        raise NotImplementedError
    
    def setErrorID(self, v):
        """Changes the value of {@code ErrorID}. If error is true, returns an error identification code.
        
           Parameters:
             - v -- the new value of ErrorID, may be of type int or the corresponding numpy type"""
        raise NotImplementedError
    
    def setRPosition_actual(self, v):
        """Changes the value of {@code rPosition_actual}. Actual position in mm +/- 1mm, may be negative although 0
        
           Parameters:
             - v -- the new value of rPosition_actual, may be of type float or the corresponding numpy type"""
        raise NotImplementedError
    
    def setSAxisMessage(self, v: str):
        """Changes the value of {@code sAxisMessage}. Status message from drive
        
           Parameters:
             - v -- the new value of sAxisMessage"""
        raise NotImplementedError
    
    
    #Indeed, there are 2.4 decorators for this, but for now we want to have all here: pythonic field access
    #backed by getter/setter and the ability to replace data classes by e.g. projecting or data enhancing
    #functionality (original idea of the "interfaces" with similar naming as in Java. It may be that the 
    #interfaces become superfluous due to the properties, but let's leave them in for now.
    bWaitForCommand = property(getBWaitForCommand, setBWaitForCommand)
    
    iFriction_actual = property(getIFriction_actual)
    
    iTension_actual = property(getITension_actual)
    Error = property(getError, setError)
    ErrorID = property(getErrorID, setErrorID)
    rPosition_actual = property(getRPosition_actual, setRPosition_actual)
    sAxisMessage = property(getSAxisMessage, setSAxisMessage)
    
