
from datetime import datetime
from decimal import Decimal

class DriveCommand:
    """Interface of the application data type DriveCommand. 
       Generated by: EASy-Producer."""
 
    
    def getIFriction_set(self) -> int:
        """Returns the value of {@code iFriction_set}. Desired friction incident in percentage, 0 is normal
        
           Returns:
             - the value of iFriction_set"""
        raise NotImplementedError
    
    def getITension_set(self) -> int:
        """Returns the value of {@code iTension_set}. Desired tension incident in percentage, 100 is normal
        
           Returns:
             - the value of iTension_set"""
        raise NotImplementedError
    
    def getRPosition(self) -> float:
        """Returns the value of {@code rPosition}. Target position in mm
        
           Returns:
             - the value of rPosition"""
        raise NotImplementedError
    
    def getRVelocity(self) -> float:
        """Returns the value of {@code rVelocity}. Movement velocity position in mm/min, always 100
        
           Returns:
             - the value of rVelocity"""
        raise NotImplementedError
    
    def getBExecute(self) -> bool:
        """Returns the value of {@code bExecute}.
        
           Returns:
             - the value of bExecute"""
        raise NotImplementedError
    
    
    def setIFriction_set(self, v):
        """Changes the value of {@code iFriction_set}. Desired friction incident in percentage, 0 is normal
        
           Parameters:
             - v -- the new value of iFriction_set, may be of type int or the corresponding numpy type"""
        raise NotImplementedError
    
    def setITension_set(self, v):
        """Changes the value of {@code iTension_set}. Desired tension incident in percentage, 100 is normal
        
           Parameters:
             - v -- the new value of iTension_set, may be of type int or the corresponding numpy type"""
        raise NotImplementedError
    
    def setRPosition(self, v):
        """Changes the value of {@code rPosition}. Target position in mm
        
           Parameters:
             - v -- the new value of rPosition, may be of type float or the corresponding numpy type"""
        raise NotImplementedError
    
    def setRVelocity(self, v):
        """Changes the value of {@code rVelocity}. Movement velocity position in mm/min, always 100
        
           Parameters:
             - v -- the new value of rVelocity, may be of type float or the corresponding numpy type"""
        raise NotImplementedError
    
    def setBExecute(self, v: bool):
        """Changes the value of {@code bExecute}.
        
           Parameters:
             - v -- the new value of bExecute"""
        raise NotImplementedError
    
    
    #Indeed, there are 2.4 decorators for this, but for now we want to have all here: pythonic field access
    #backed by getter/setter and the ability to replace data classes by e.g. projecting or data enhancing
    #functionality (original idea of the "interfaces" with similar naming as in Java. It may be that the 
    #interfaces become superfluous due to the properties, but let's leave them in for now.
    iFriction_set = property(getIFriction_set, setIFriction_set)
    iTension_set = property(getITension_set, setITension_set)
    rPosition = property(getRPosition, setRPosition)
    rVelocity = property(getRVelocity, setRVelocity)
    bExecute = property(getBExecute, setBExecute)
    
