
from datetime import datetime
from decimal import Decimal

class ImageInput:
    """Interface of the application data type ImageInput. 
       Generated by: EASy-Producer."""
 
    
    def getImage(self) -> str:
        """Returns the value of {@code image}.
        
           Returns:
             - the value of image"""
        raise NotImplementedError
    
    def getImageUri(self) -> str:
        """Returns the value of {@code imageUri}.
        
           Returns:
             - the value of imageUri"""
        raise NotImplementedError
    
    def getSide(self) -> str:
        """Returns the value of {@code side}.
        
           Returns:
             - the value of side"""
        raise NotImplementedError
    
    def getRobotId(self) -> int:
        """Returns the value of {@code robotId}.
        
           Returns:
             - the value of robotId"""
        raise NotImplementedError
    
    
    def setImage(self, v: str):
        """Changes the value of {@code image}.
        
           Parameters:
             - v -- the new value of image"""
        raise NotImplementedError
    
    def setImageUri(self, v: str):
        """Changes the value of {@code imageUri}.
        
           Parameters:
             - v -- the new value of imageUri"""
        raise NotImplementedError
    
    def setSide(self, v: str):
        """Changes the value of {@code side}.
        
           Parameters:
             - v -- the new value of side"""
        raise NotImplementedError
    
    def setRobotId(self, v):
        """Changes the value of {@code robotId}.
        
           Parameters:
             - v -- the new value of robotId, may be of type int or the corresponding numpy type"""
        raise NotImplementedError
    
    
    #Indeed, there are 2.4 decorators for this, but for now we want to have all here: pythonic field access
    #backed by getter/setter and the ability to replace data classes by e.g. projecting or data enhancing
    #functionality (original idea of the "interfaces" with similar naming as in Java. It may be that the 
    #interfaces become superfluous due to the properties, but let's leave them in for now.
    image = property(getImage, setImage)
    imageUri = property(getImageUri, setImageUri)
    side = property(getSide, setSide)
    robotId = property(getRobotId, setRobotId)
    
