from datatypes.LenzeDriveMeasurementChannel import LenzeDriveMeasurementChannel
from datetime import datetime
from decimal import Decimal

class LenzeDriveMeasurementChannelImpl(LenzeDriveMeasurementChannel):
    """Implementation of the application data type LenzeDriveMeasurementChannel. 
       Generated by: EASy-Producer."""
 
    #Mapped into properties without leading _ below resembling getter/setter
    
    _channelNo: int = 0
    _timestamp: str = ""
    _timebase: float = 0.0
    _samplerate: float = 0.0
    _connection: str = ""
    _ParameterID: str = ""
    _name: str = ""
    _unit: str = ""
    _data: str = ""
    
    def getChannelNo(self) -> int:
        """Returns the value of {@code channelNo}.
        
           Returns:
             - the value of channelNo"""
        return self._channelNo
    
    def getTimestamp(self) -> str:
        """Returns the value of {@code timestamp}. recording point in time
        
           Returns:
             - the value of timestamp"""
        return self._timestamp
    
    def getTimebase(self) -> float:
        """Returns the value of {@code timebase}. not relevant
        
           Returns:
             - the value of timebase"""
        return self._timebase
    
    def getSamplerate(self) -> float:
        """Returns the value of {@code samplerate}. sample rate in (fraction of) seconds, time period between two measurements
        
           Returns:
             - the value of samplerate"""
        return self._samplerate
    
    def getConnection(self) -> str:
        """Returns the value of {@code connection}. unique ID, IP address of source (converter)
        
           Returns:
             - the value of connection"""
        return self._connection
    
    def getParameterID(self) -> str:
        """Returns the value of {@code ParameterID}. unique naming of recorded state variable for this channel
        
           Returns:
             - the value of ParameterID"""
        return self._ParameterID
    
    def getName(self) -> str:
        """Returns the value of {@code name}. name of the parameter
        
           Returns:
             - the value of name"""
        return self._name
    
    def getUnit(self) -> str:
        """Returns the value of {@code unit}. unit of recorded data
        
           Returns:
             - the value of unit"""
        return self._unit
    
    def getData(self) -> str:
        """Returns the value of {@code data}. array of measurements, time axis can be calculated via sample rate
        
           Returns:
             - the value of data"""
        return self._data
    
    
    def setChannelNo(self, v):
        """Changes the value of {@code channelNo}.
        
           Parameters:
             - v -- the new value of channelNo, may be of type int or the corresponding numpy type"""
        if ("numpy" in str(type(v))):
            self._channelNo = v.item()
        else:
            self._channelNo = v
    
    def setTimestamp(self, v: str):
        """Changes the value of {@code timestamp}. recording point in time
        
           Parameters:
             - v -- the new value of timestamp"""
        self._timestamp = v
    
    def setTimebase(self, v):
        """Changes the value of {@code timebase}. not relevant
        
           Parameters:
             - v -- the new value of timebase, may be of type float or the corresponding numpy type"""
        if ("numpy" in str(type(v))):
            self._timebase = v.item()
        else:
            self._timebase = v
    
    def setSamplerate(self, v):
        """Changes the value of {@code samplerate}. sample rate in (fraction of) seconds, time period between two measurements
        
           Parameters:
             - v -- the new value of samplerate, may be of type float or the corresponding numpy type"""
        if ("numpy" in str(type(v))):
            self._samplerate = v.item()
        else:
            self._samplerate = v
    
    def setConnection(self, v: str):
        """Changes the value of {@code connection}. unique ID, IP address of source (converter)
        
           Parameters:
             - v -- the new value of connection"""
        self._connection = v
    
    def setParameterID(self, v: str):
        """Changes the value of {@code ParameterID}. unique naming of recorded state variable for this channel
        
           Parameters:
             - v -- the new value of ParameterID"""
        self._ParameterID = v
    
    def setName(self, v: str):
        """Changes the value of {@code name}. name of the parameter
        
           Parameters:
             - v -- the new value of name"""
        self._name = v
    
    def setUnit(self, v: str):
        """Changes the value of {@code unit}. unit of recorded data
        
           Parameters:
             - v -- the new value of unit"""
        self._unit = v
    
    def setData(self, v: str):
        """Changes the value of {@code data}. array of measurements, time axis can be calculated via sample rate
        
           Parameters:
             - v -- the new value of data"""
        self._data = v
    
    
    #Indeed, there are 2.4 decorators for this, but for now we want to have all here: pythonic field access
    #backed by getter/setter and the ability to replace data classes by e.g. projecting or data enhancing
    #functionality (original idea of the "interfaces" with similar naming as in Java. It may be that the 
    #interfaces become superfluous due to the properties, but let's leave them in for now.
    channelNo = property(getChannelNo, setChannelNo)
    timestamp = property(getTimestamp, setTimestamp)
    timebase = property(getTimebase, setTimebase)
    samplerate = property(getSamplerate, setSamplerate)
    connection = property(getConnection, setConnection)
    ParameterID = property(getParameterID, setParameterID)
    name = property(getName, setName)
    unit = property(getUnit, setUnit)
    data = property(getData, setData)
    
