
from datetime import datetime
from decimal import Decimal

class LenzeDriveMeasurementProcess:
    """Interface of the application data type LenzeDriveMeasurementProcess. 
       Generated by: EASy-Producer."""
 
    
    def getChannelcount(self) -> int:
        """Returns the value of {@code channelcount}. number of channels in following array
        
           Returns:
             - the value of channelcount"""
        raise NotImplementedError
    
    def getChannels(self) -> list:
        """Returns the value of {@code channels}. measurements of process factor, one per channel
        
           Returns:
             - the value of channels"""
        raise NotImplementedError
    
    
    def setChannelcount(self, v):
        """Changes the value of {@code channelcount}. number of channels in following array
        
           Parameters:
             - v -- the new value of channelcount, may be of type int or the corresponding numpy type"""
        raise NotImplementedError
    
    def setChannels(self, v: list):
        """Changes the value of {@code channels}. measurements of process factor, one per channel
        
           Parameters:
             - v -- the new value of channels"""
        raise NotImplementedError
    
    
    #Indeed, there are 2.4 decorators for this, but for now we want to have all here: pythonic field access
    #backed by getter/setter and the ability to replace data classes by e.g. projecting or data enhancing
    #functionality (original idea of the "interfaces" with similar naming as in Java. It may be that the 
    #interfaces become superfluous due to the properties, but let's leave them in for now.
    channelcount = property(getChannelcount, setChannelcount)
    channels = property(getChannels, setChannels)
    
