from json import JSONEncoder
import json
from datetime import datetime
from TypeTranslatorToString import TypeTranslatorToString
import Registry
from datatypes.Command import Command
from datatypes.CommandImpl import CommandImpl



class CommandEncoder(JSONEncoder):
    """JSON encoder class for Command.
    Generated by: EASy-Producer."""

    def default(self, o):
        """Provides access to the attributes in o.
        
        Parameters:
          - o -- the object to serialize
        Returns:
          dict
            the attributes
        """
        tmp = dict()
        for key in o.__dict__:
            k = key[1:] # by generation convention
            tmp[k] = o.__dict__[key]
        
        return tmp
    

class CommandSerializer(TypeTranslatorToString):
    """JSON transport serializer for Command.
       Generated by: EASy-Producer."""
                
    def __init__(self):
        """Initializes the transformer.""" 
        Registry.serializers["Command"] = self
        Registry.types[Command] = "Command"
        Registry.serializers["CommandImpl"] = self # there is a serializer for the Impl
        Registry.types[CommandImpl] = "Command" # the Impl maps back to the type name
    
    def readFrom(self, data: str) -> Command:
        """Turns bytes into a String.
        
        Parameters:
          - data -- the data string
        Returns:
          object
            the deserialized object
        """
    
        result = CommandImpl()
        jTmp = json.loads(data)
        tmp = dict()
        for key in jTmp:
            k = "_" + str(key) # by generation convention
            tmp[k] = jTmp[key]
        
        result.__dict__ = tmp
        return result

    def writeTo(self, source: Command) -> str:
        """Turns an object into a String.
        
        Parameters:
          - source -- the object
        Returns:
          bytes
            the serialized data string
        """
        
        return CommandEncoder().encode(source).encode("UTF-8").decode()
        
    def readFromCommand(d: dict) -> Command:
        """Turns a dict into an object of type Command for deep deserialization.
        
        Parameters:
          - d -- dict
        Returns:
          Command
            the object, may be None
        """
        if d is None:
            return None
        else:
            tmp = dict()
            result = CommandImpl()
            for key in d:
                k = "_" + str(key) # by generation convention
                tmp[k] = d[key]
            
            result.__dict__ = tmp
            return result
    
    def writeToCommand(o: Command) -> dict:
        """Turns an object of type Command into a dict for serialization.
        
        Parameters:
          - o -- the object, may be None
        Returns:
          dict
            the dict, may be None
        """
        if o is None:
            return None
        else:
            result = dict()
            for key in o.__dict__:
                k = key[1:] # by generation convention
                result[k] = o.__dict__[key]

CommandSerializer()
