from json import JSONEncoder
import json
from datetime import datetime
from TypeTranslatorToString import TypeTranslatorToString
import Registry
from datatypes.PlcEnergyMeasurementChannel import PlcEnergyMeasurementChannel
from datatypes.PlcEnergyMeasurementChannelImpl import PlcEnergyMeasurementChannelImpl





class PlcEnergyMeasurementChannelEncoder(JSONEncoder):
    """JSON encoder class for PlcEnergyMeasurementChannel.
    Generated by: EASy-Producer."""

    def default(self, o):
        """Provides access to the attributes in o.
        
        Parameters:
          - o -- the object to serialize
        Returns:
          dict
            the attributes
        """
        tmp = dict()
        for key in o.__dict__:
            k = key[1:] # by generation convention
            tmp[k] = o.__dict__[key]
        
        return tmp
    

class PlcEnergyMeasurementChannelSerializer(TypeTranslatorToString):
    """JSON transport serializer for PlcEnergyMeasurementChannel.
       Generated by: EASy-Producer."""
                
    def __init__(self):
        """Initializes the transformer.""" 
        Registry.serializers["PlcEnergyMeasurementChannel"] = self
        Registry.types[PlcEnergyMeasurementChannel] = "PlcEnergyMeasurementChannel"
        Registry.serializers["PlcEnergyMeasurementChannelImpl"] = self # there is a serializer for the Impl
        Registry.types[PlcEnergyMeasurementChannelImpl] = "PlcEnergyMeasurementChannel" # the Impl maps back to the type name
    
    def readFrom(self, data: str) -> PlcEnergyMeasurementChannel:
        """Turns bytes into a String.
        
        Parameters:
          - data -- the data string
        Returns:
          object
            the deserialized object
        """
    
        result = PlcEnergyMeasurementChannelImpl()
        jTmp = json.loads(data)
        tmp = dict()
        for key in jTmp:
            k = "_" + str(key) # by generation convention
            tmp[k] = jTmp[key]
        if "_values" in tmp:
            tmplist = tmp["_values"]
            tmp["_values"] = []
            for i in tmplist: 
                tmp["_values"].append(i)
                
        
        
        
        
        result.__dict__ = tmp
        return result

    def writeTo(self, source: PlcEnergyMeasurementChannel) -> str:
        """Turns an object into a String.
        
        Parameters:
          - source -- the object
        Returns:
          bytes
            the serialized data string
        """
        
        return PlcEnergyMeasurementChannelEncoder().encode(source).encode("UTF-8").decode()
        
    def readFromPlcEnergyMeasurementChannel(d: dict) -> PlcEnergyMeasurementChannel:
        """Turns a dict into an object of type PlcEnergyMeasurementChannel for deep deserialization.
        
        Parameters:
          - d -- dict
        Returns:
          PlcEnergyMeasurementChannel
            the object, may be None
        """
        if d is None:
            return None
        else:
            tmp = dict()
            result = PlcEnergyMeasurementChannelImpl()
            for key in d:
                k = "_" + str(key) # by generation convention
                tmp[k] = d[key]
            if "_values" in tmp:
                tmplist = tmp["_values"]
                tmp["_values"] = []
                for i in tmplist: 
                    tmp["_values"].append(i)
                    
            
            
            
            
            result.__dict__ = tmp
            return result
    
    def writeToPlcEnergyMeasurementChannel(o: PlcEnergyMeasurementChannel) -> dict:
        """Turns an object of type PlcEnergyMeasurementChannel into a dict for serialization.
        
        Parameters:
          - o -- the object, may be None
        Returns:
          dict
            the dict, may be None
        """
        if o is None:
            return None
        else:
            result = dict()
            for key in o.__dict__:
                k = key[1:] # by generation convention
                result[k] = o.__dict__[key]

PlcEnergyMeasurementChannelSerializer()
